/**
 * Copyright 1998-2007, CHISEL Group, University of Victoria, Victoria, BC, Canada.
 * All rights reserved.
 */
package ca.uvic.csr.shrimp.adapter;

import java.util.Properties;

import javax.swing.JEditorPane;

import ca.uvic.csr.shrimp.PanelModeConstants;
import ca.uvic.csr.shrimp.DataBean.event.AnnotationPanelLoadEvent;
import ca.uvic.csr.shrimp.DataBean.event.AnnotationPanelSaveEvent;
import ca.uvic.csr.shrimp.DataBean.event.CustomizedPanelActionEvent;
import ca.uvic.csr.shrimp.DataBean.event.CustomizedPanelActionListener;
import ca.uvic.csr.shrimp.ShrimpProject.ShrimpProject;


/**
 * @author Rob Lintern
 */
public class AnnotationPanelActionAdapter implements CustomizedPanelActionListener {
	private ShrimpProject project;
	
	public AnnotationPanelActionAdapter (ShrimpProject project) {
		this.project = project;
	}
	
	/**
	 * @see ca.uvic.csr.shrimp.DataBean.event.CustomizedPanelActionListener#actionPerformed(CustomizedPanelActionEvent)
	 */
	public void actionPerformed(CustomizedPanelActionEvent e) {
		if (e instanceof AnnotationPanelSaveEvent) {
			AnnotationPanelSaveEvent apse = (AnnotationPanelSaveEvent) e;
			long artifactID = apse.getArtifactID();
			String annotation = apse.getAnnotation();
			Properties properties = project.getProperties();
			properties.setProperty("annotation" + artifactID, annotation);
				
		} else if (e instanceof AnnotationPanelLoadEvent) {
			AnnotationPanelLoadEvent aple = (AnnotationPanelLoadEvent) e;
			long artifactID = aple.getArtifactID();
			JEditorPane editorPane = aple.getJEditorPane();
			Properties properties = project.getProperties();
			String annotation = properties.getProperty("annotation" + artifactID);
			if (annotation == null) 				
				editorPane.setText("");
			else 
				editorPane.setText(annotation);
		}
	}

	/**
	 * @see ca.uvic.csr.shrimp.DataBean.event.CustomizedPanelActionListener#getCustomizedPanelType()
	 */
	public String getCustomizedPanelType() {
		return PanelModeConstants.PANEL_ANNOTATION;
	}

}
